<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <h2 class="m-5 text-center">Danh sách đơn hàng</h2>
                <table class="table text-center table-striped" id="table-order">
                    <thead>
                        <tr>
                            <th scope="col">Order Code</th>
                            <th scope="col">Kích cỡ combo</th>
                            <th scope="col">Loại pizza</th>
                            <th scope="col">Nước uống</th>
                            <th scope="col">Thành tiền</th>
                            <th scope="col">Họ và tên</th>
                            <th scope="col">Số điện thoại</th>
                            <th scope="col">Trạng thái</th>
                            <th scope="col">Chi tiết</th>
                        </tr>
                    </thead>
                    <tbody id="table-body">

                    </tbody>
                </table>
            </div>
        </div>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        
        const gEND_TABLE = -1;

        const gCODE_CELL = 0;
        const gCOMBO_CELL = 1;
        const gPIZZA_CELL = 2;
        const gDRINK_CELL = 3;
        const gTOTAL_CELL = 4;
        const gNAME_CELL = 5;
        const gPHONE_CELL = 6;
        const gSTATUS_CELL = 7;
        const gDETAIL_CELL = 8;

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // function thực hiện khi load trang
        function onPageLoading() {
            // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
            // B2: Validate dữ liệu (trong bài này bước này ko cần)
            // B3: Thực hiện việc gọi API từ server Server
            var vXmlHttpGetAllOrders = new XMLHttpRequest();
            callApiToGetAllOrders(vXmlHttpGetAllOrders);
            vXmlHttpGetAllOrders.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
                    loadOrderToTable(vXmlHttpGetAllOrders);
                }
            }
        }

        // function xử lý sự kiện click button Chi Tiết
        function onBtnDetailClick(paramElement) {
            let vOrderCode = paramElement.dataset.code;
            let vOrderId = paramElement.dataset.id;
            let vUrl = `order.detail.html?id=${vOrderId}&code=${vOrderCode}`;
            window.location.href = vUrl;
        }
        
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // function gọi api để lấy all orders
        function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
            const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
            paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
            paramXMLHttpGetAllOrders.send();
        }

        // input: xml http request đã đươc trả lời
        // ouptut/end: dữ liệu hiên thi trên bảng
        function loadOrderToTable(paramXmlHttp) {
            // chuyển json string sang object
            let vOrderList = JSON.parse(paramXmlHttp.responseText);
            let vTableBody = document.getElementById("table-body");
            vTableBody.innerHTML = "";
            // đưa data danh sách đơn hàng vào table
            for (let bIndex = 0; bIndex < vOrderList.length; bIndex ++) {
                // thêm dòng mới vào cuối table
                let bNewRow = vTableBody.insertRow(gEND_TABLE);
                // thêm cell tương ứng
                let bCodeCell = bNewRow.insertCell(gCODE_CELL);
                let bComboCell = bNewRow.insertCell(gCOMBO_CELL);
                let bPizzaCell = bNewRow.insertCell(gPIZZA_CELL);
                let bDrinkCell = bNewRow.insertCell(gDRINK_CELL);
                let bTotalCell = bNewRow.insertCell(gTOTAL_CELL);
                let bNameCell = bNewRow.insertCell(gNAME_CELL);
                let bPhoneCell = bNewRow.insertCell(gPHONE_CELL);
                let bStatusCell = bNewRow.insertCell(gSTATUS_CELL);
                let bDetailCell = bNewRow.insertCell(gDETAIL_CELL);
                // gán giá trị cho cell table
                bCodeCell.innerHTML = vOrderList[bIndex].orderCode;
                bComboCell.innerHTML = vOrderList[bIndex].kichCo;
                bPizzaCell.innerHTML = vOrderList[bIndex].loaiPizza;
                bDrinkCell.innerHTML = vOrderList[bIndex].idLoaiNuocUong;
                bTotalCell.innerHTML = vOrderList[bIndex].thanhTien;
                bNameCell.innerHTML = vOrderList[bIndex].hoTen;
                bPhoneCell.innerHTML = vOrderList[bIndex].soDienThoai;
                bStatusCell.innerHTML = vOrderList[bIndex].trangThai;
                // thêm button vào ô chi tiết
                let bButtonDetail = document.createElement("button");
                bDetailCell.appendChild(bButtonDetail);
                bButtonDetail.className = "btn btn-success";
                bButtonDetail.innerHTML = "Chi Tiết";
                bButtonDetail.setAttribute("data-code", vOrderList[bIndex].orderCode);
                bButtonDetail.setAttribute("data-id", vOrderList[bIndex].id);
                bButtonDetail.setAttribute("onclick", "onBtnDetailClick(this)");
            }
        }
        
    </script>

</body>

</html>